using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_Contabilidad._0_Modelos;
using Exferia_Contabilidad.General;
using Exferia_EntityFramework;
using Exferia_General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_Contabilidad._3_Vistas.Listados
{
    public class ABS_Listado_CTA_InformesContablesLineaDesglose : ABS_Listado
    {
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

        //Constructor
        public ABS_Listado_CTA_InformesContablesLineaDesglose()
        {
            Rellenar_columnas();
        }

        private void Rellenar_columnas()
        {
            //id
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.id), "id", G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, false, false, "", null, false));
           
            //linea
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.linea), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.linea), "Linea", G_ENUM_TIPOSDATOS.INT, false, 50, true, true, true, false, "", null, false));

            //Cuenta
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.Cuenta_Texto), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.Cuenta_Texto), "Cuenta", G_ENUM_TIPOSDATOS.TEXT, false, 400, false,true,true, false, "", null, false));

            //control_DebeHaber
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.control_DebeHaber), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.control_DebeHaber), "control Debe/Haber", G_ENUM_TIPOSDATOS.TEXT, false, 50, true, false, false, false, "", null, true));

            //Mayor
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_MAYOR = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.idMayor), nameof(CTA_Mayor), nameof(CTA_Mayor.id), nameof(CTA_Mayor.codigo), nameof(CTA_Mayor.descripcion), nameof(CTA_Mayor.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.idMayor), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.idMayor), "Mayor", G_ENUM_TIPOSDATOS.RELACIONADA,true, 0, true,true, false, true, "", null, true, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_MAYOR));

            //Grupo_1
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_PLANGENERALCONTABLE = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.idPlanGeneralContable), nameof(CTA_PlanGeneralContable), nameof(CTA_PlanGeneralContable.id), nameof(CTA_PlanGeneralContable.codigo), nameof(CTA_PlanGeneralContable.descripcion), nameof(CTA_PlanGeneralContable.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.idPlanGeneralContable), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.idPlanGeneralContable), "Plan general contable", G_ENUM_TIPOSDATOS.RELACIONADA, true, 0, true, true, false, true, "", null, true, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_PLANGENERALCONTABLE));

        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }

        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_CTA_INFORMESCONTABLESLINEADESGLOSE);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_CTA_INFORMESCONTABLESLINEADESGLOSE;
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.linea);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "0";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
